<class>
 	<keyword> class </keyword>
 	<identifier> MathsToo </identifier>
 	<symbol> { </symbol>
 	<subroutineDec>
 	 	<keyword> function </keyword>
 	 	<keyword> int </keyword>
 	 	<identifier> lsl </identifier>
 	 	<symbol> ( </symbol>
 	 	<parameterList>
 	 	 	<keyword> int </keyword>
 	 	 	<identifier> v </identifier>
 	 	 	<symbol> , </symbol>
 	 	 	<keyword> int </keyword>
 	 	 	<identifier> n </identifier>
 	 	</parameterList>
 	 	<symbol> ) </symbol>
 	 	<subroutineBody>
 	 	 	<symbol> { </symbol>
 	 	 	<statements>
 	 	 	 	<whileStatement>
 	 	 	 	 	<keyword> while </keyword>
 	 	 	 	 	<symbol> ( </symbol>
 	 	 	 	 	<expression>
 	 	 	 	 	 	<term>
 	 	 	 	 	 	 	<identifier> n </identifier>
 	 	 	 	 	 	</term>
 	 	 	 	 	 	<symbol> &gt; </symbol>
 	 	 	 	 	 	<term>
 	 	 	 	 	 	 	<integerConstant> 0 </integerConstant>
 	 	 	 	 	 	</term>
 	 	 	 	 	</expression>
 	 	 	 	 	<symbol> ) </symbol>
 	 	 	 	 	<symbol> { </symbol>
 	 	 	 	 	<statements>
 	 	 	 	 	 	<letStatement>
 	 	 	 	 	 	 	<keyword> let </keyword>
 	 	 	 	 	 	 	<identifier> v </identifier>
 	 	 	 	 	 	 	<symbol> = </symbol>
 	 	 	 	 	 	 	<expression>
 	 	 	 	 	 	 	 	<term>
 	 	 	 	 	 	 	 	 	<identifier> v </identifier>
 	 	 	 	 	 	 	 	</term>
 	 	 	 	 	 	 	 	<symbol> + </symbol>
 	 	 	 	 	 	 	 	<term>
 	 	 	 	 	 	 	 	 	<identifier> v </identifier>
 	 	 	 	 	 	 	 	</term>
 	 	 	 	 	 	 	</expression>
 	 	 	 	 	 	 	<symbol> ; </symbol>
 	 	 	 	 	 	</letStatement>
 	 	 	 	 	 	<letStatement>
 	 	 	 	 	 	 	<keyword> let </keyword>
 	 	 	 	 	 	 	<identifier> n </identifier>
 	 	 	 	 	 	 	<symbol> = </symbol>
 	 	 	 	 	 	 	<expression>
 	 	 	 	 	 	 	 	<term>
 	 	 	 	 	 	 	 	 	<identifier> n </identifier>
 	 	 	 	 	 	 	 	</term>
 	 	 	 	 	 	 	 	<symbol> - </symbol>
 	 	 	 	 	 	 	 	<term>
 	 	 	 	 	 	 	 	 	<integerConstant> 1 </integerConstant>
 	 	 	 	 	 	 	 	</term>
 	 	 	 	 	 	 	</expression>
 	 	 	 	 	 	 	<symbol> ; </symbol>
 	 	 	 	 	 	</letStatement>
 	 	 	 	 	</statements>
 	 	 	 	 	<symbol> } </symbol>
 	 	 	 	</whileStatement>
 	 	 	 	<returnStatement>
 	 	 	 	 	<keyword> return </keyword>
 	 	 	 	 	<expression>
 	 	 	 	 	 	<term>
 	 	 	 	 	 	 	<identifier> v </identifier>
 	 	 	 	 	 	</term>
 	 	 	 	 	</expression>
 	 	 	 	 	<symbol> ; </symbol>
 	 	 	 	</returnStatement>
 	 	 	</statements>
 	 	 	<symbol> } </symbol>
 	 	</subroutineBody>
 	</subroutineDec>
 	<subroutineDec>
 	 	<keyword> function </keyword>
 	 	<keyword> int </keyword>
 	 	<identifier> lsr </identifier>
 	 	<symbol> ( </symbol>
 	 	<parameterList>
 	 	 	<keyword> int </keyword>
 	 	 	<identifier> v </identifier>
 	 	 	<symbol> , </symbol>
 	 	 	<keyword> int </keyword>
 	 	 	<identifier> n </identifier>
 	 	</parameterList>
 	 	<symbol> ) </symbol>
 	 	<subroutineBody>
 	 	 	<symbol> { </symbol>
 	 	 	<varDec>
 	 	 	 	<keyword> var </keyword>
 	 	 	 	<keyword> int </keyword>
 	 	 	 	<identifier> mask </identifier>
 	 	 	 	<symbol> , </symbol>
 	 	 	 	<identifier> maxMask </identifier>
 	 	 	 	<symbol> , </symbol>
 	 	 	 	<identifier> outMask </identifier>
 	 	 	 	<symbol> , </symbol>
 	 	 	 	<identifier> out </identifier>
 	 	 	 	<symbol> ; </symbol>
 	 	 	</varDec>
 	 	 	<statements>
 	 	 	 	<letStatement>
 	 	 	 	 	<keyword> let </keyword>
 	 	 	 	 	<identifier> mask </identifier>
 	 	 	 	 	<symbol> = </symbol>
 	 	 	 	 	<expression>
 	 	 	 	 	 	<term>
 	 	 	 	 	 	 	<integerConstant> 1 </integerConstant>
 	 	 	 	 	 	</term>
 	 	 	 	 	</expression>
 	 	 	 	 	<symbol> ; </symbol>
 	 	 	 	</letStatement>
 	 	 	 	<letStatement>
 	 	 	 	 	<keyword> let </keyword>
 	 	 	 	 	<identifier> n </identifier>
 	 	 	 	 	<symbol> = </symbol>
 	 	 	 	 	<expression>
 	 	 	 	 	 	<term>
 	 	 	 	 	 	 	<identifier> n </identifier>
 	 	 	 	 	 	</term>
 	 	 	 	 	 	<symbol> - </symbol>
 	 	 	 	 	 	<term>
 	 	 	 	 	 	 	<integerConstant> 1 </integerConstant>
 	 	 	 	 	 	</term>
 	 	 	 	 	</expression>
 	 	 	 	 	<symbol> ; </symbol>
 	 	 	 	</letStatement>
 	 	 	 	<whileStatement>
 	 	 	 	 	<keyword> while </keyword>
 	 	 	 	 	<symbol> ( </symbol>
 	 	 	 	 	<expression>
 	 	 	 	 	 	<term>
 	 	 	 	 	 	 	<identifier> n </identifier>
 	 	 	 	 	 	</term>
 	 	 	 	 	 	<symbol> &gt; </symbol>
 	 	 	 	 	 	<term>
 	 	 	 	 	 	 	<integerConstant> 0 </integerConstant>
 	 	 	 	 	 	</term>
 	 	 	 	 	</expression>
 	 	 	 	 	<symbol> ) </symbol>
 	 	 	 	 	<symbol> { </symbol>
 	 	 	 	 	<statements>
 	 	 	 	 	 	<letStatement>
 	 	 	 	 	 	 	<keyword> let </keyword>
 	 	 	 	 	 	 	<identifier> mask </identifier>
 	 	 	 	 	 	 	<symbol> = </symbol>
 	 	 	 	 	 	 	<expression>
 	 	 	 	 	 	 	 	<term>
 	 	 	 	 	 	 	 	 	<identifier> mask </identifier>
 	 	 	 	 	 	 	 	</term>
 	 	 	 	 	 	 	 	<symbol> + </symbol>
 	 	 	 	 	 	 	 	<term>
 	 	 	 	 	 	 	 	 	<identifier> mask </identifier>
 	 	 	 	 	 	 	 	</term>
 	 	 	 	 	 	 	</expression>
 	 	 	 	 	 	 	<symbol> ; </symbol>
 	 	 	 	 	 	</letStatement>
 	 	 	 	 	 	<letStatement>
 	 	 	 	 	 	 	<keyword> let </keyword>
 	 	 	 	 	 	 	<identifier> n </identifier>
 	 	 	 	 	 	 	<symbol> = </symbol>
 	 	 	 	 	 	 	<expression>
 	 	 	 	 	 	 	 	<term>
 	 	 	 	 	 	 	 	 	<identifier> n </identifier>
 	 	 	 	 	 	 	 	</term>
 	 	 	 	 	 	 	 	<symbol> - </symbol>
 	 	 	 	 	 	 	 	<term>
 	 	 	 	 	 	 	 	 	<integerConstant> 1 </integerConstant>
 	 	 	 	 	 	 	 	</term>
 	 	 	 	 	 	 	</expression>
 	 	 	 	 	 	 	<symbol> ; </symbol>
 	 	 	 	 	 	</letStatement>
 	 	 	 	 	</statements>
 	 	 	 	 	<symbol> } </symbol>
 	 	 	 	</whileStatement>
 	 	 	 	<letStatement>
 	 	 	 	 	<keyword> let </keyword>
 	 	 	 	 	<identifier> maxMask </identifier>
 	 	 	 	 	<symbol> = </symbol>
 	 	 	 	 	<expression>
 	 	 	 	 	 	<term>
 	 	 	 	 	 	 	<symbol> - </symbol>
 	 	 	 	 	 	 	<term>
 	 	 	 	 	 	 	 	<integerConstant> 32767 </integerConstant>
 	 	 	 	 	 	 	</term>
 	 	 	 	 	 	</term>
 	 	 	 	 	 	<symbol> - </symbol>
 	 	 	 	 	 	<term>
 	 	 	 	 	 	 	<integerConstant> 1 </integerConstant>
 	 	 	 	 	 	</term>
 	 	 	 	 	</expression>
 	 	 	 	 	<symbol> ; </symbol>
 	 	 	 	</letStatement>
 	 	 	 	<letStatement>
 	 	 	 	 	<keyword> let </keyword>
 	 	 	 	 	<identifier> outMask </identifier>
 	 	 	 	 	<symbol> = </symbol>
 	 	 	 	 	<expression>
 	 	 	 	 	 	<term>
 	 	 	 	 	 	 	<integerConstant> 1 </integerConstant>
 	 	 	 	 	 	</term>
 	 	 	 	 	</expression>
 	 	 	 	 	<symbol> ; </symbol>
 	 	 	 	</letStatement>
 	 	 	 	<whileStatement>
 	 	 	 	 	<keyword> while </keyword>
 	 	 	 	 	<symbol> ( </symbol>
 	 	 	 	 	<expression>
 	 	 	 	 	 	<term>
 	 	 	 	 	 	 	<symbol> ~ </symbol>
 	 	 	 	 	 	 	<term>
 	 	 	 	 	 	 	 	<symbol> ( </symbol>
 	 	 	 	 	 	 	 	<expression>
 	 	 	 	 	 	 	 	 	<term>
 	 	 	 	 	 	 	 	 	 	<identifier> mask </identifier>
 	 	 	 	 	 	 	 	 	</term>
 	 	 	 	 	 	 	 	 	<symbol> = </symbol>
 	 	 	 	 	 	 	 	 	<term>
 	 	 	 	 	 	 	 	 	 	<identifier> maxMask </identifier>
 	 	 	 	 	 	 	 	 	</term>
 	 	 	 	 	 	 	 	</expression>
 	 	 	 	 	 	 	 	<symbol> ) </symbol>
 	 	 	 	 	 	 	</term>
 	 	 	 	 	 	</term>
 	 	 	 	 	</expression>
 	 	 	 	 	<symbol> ) </symbol>
 	 	 	 	 	<symbol> { </symbol>
 	 	 	 	 	<statements>
 	 	 	 	 	 	<letStatement>
 	 	 	 	 	 	 	<keyword> let </keyword>
 	 	 	 	 	 	 	<identifier> mask </identifier>
 	 	 	 	 	 	 	<symbol> = </symbol>
 	 	 	 	 	 	 	<expression>
 	 	 	 	 	 	 	 	<term>
 	 	 	 	 	 	 	 	 	<identifier> mask </identifier>
 	 	 	 	 	 	 	 	</term>
 	 	 	 	 	 	 	 	<symbol> + </symbol>
 	 	 	 	 	 	 	 	<term>
 	 	 	 	 	 	 	 	 	<identifier> mask </identifier>
 	 	 	 	 	 	 	 	</term>
 	 	 	 	 	 	 	</expression>
 	 	 	 	 	 	 	<symbol> ; </symbol>
 	 	 	 	 	 	</letStatement>
 	 	 	 	 	 	<ifStatement>
 	 	 	 	 	 	 	<keyword> if </keyword>
 	 	 	 	 	 	 	<symbol> ( </symbol>
 	 	 	 	 	 	 	<expression>
 	 	 	 	 	 	 	 	<term>
 	 	 	 	 	 	 	 	 	<identifier> v </identifier>
 	 	 	 	 	 	 	 	</term>
 	 	 	 	 	 	 	 	<symbol> &amp; </symbol>
 	 	 	 	 	 	 	 	<term>
 	 	 	 	 	 	 	 	 	<identifier> mask </identifier>
 	 	 	 	 	 	 	 	</term>
 	 	 	 	 	 	 	</expression>
 	 	 	 	 	 	 	<symbol> ) </symbol>
 	 	 	 	 	 	 	<symbol> { </symbol>
 	 	 	 	 	 	 	<statements>
 	 	 	 	 	 	 	 	<letStatement>
 	 	 	 	 	 	 	 	 	<keyword> let </keyword>
 	 	 	 	 	 	 	 	 	<identifier> out </identifier>
 	 	 	 	 	 	 	 	 	<symbol> = </symbol>
 	 	 	 	 	 	 	 	 	<expression>
 	 	 	 	 	 	 	 	 	 	<term>
 	 	 	 	 	 	 	 	 	 	 	<identifier> out </identifier>
 	 	 	 	 	 	 	 	 	 	</term>
 	 	 	 	 	 	 	 	 	 	<symbol> | </symbol>
 	 	 	 	 	 	 	 	 	 	<term>
 	 	 	 	 	 	 	 	 	 	 	<identifier> outMask </identifier>
 	 	 	 	 	 	 	 	 	 	</term>
 	 	 	 	 	 	 	 	 	</expression>
 	 	 	 	 	 	 	 	 	<symbol> ; </symbol>
 	 	 	 	 	 	 	 	</letStatement>
 	 	 	 	 	 	 	</statements>
 	 	 	 	 	 	 	<symbol> } </symbol>
 	 	 	 	 	 	</ifStatement>
 	 	 	 	 	 	<letStatement>
 	 	 	 	 	 	 	<keyword> let </keyword>
 	 	 	 	 	 	 	<identifier> outMask </identifier>
 	 	 	 	 	 	 	<symbol> = </symbol>
 	 	 	 	 	 	 	<expression>
 	 	 	 	 	 	 	 	<term>
 	 	 	 	 	 	 	 	 	<identifier> outMask </identifier>
 	 	 	 	 	 	 	 	</term>
 	 	 	 	 	 	 	 	<symbol> + </symbol>
 	 	 	 	 	 	 	 	<term>
 	 	 	 	 	 	 	 	 	<identifier> outMask </identifier>
 	 	 	 	 	 	 	 	</term>
 	 	 	 	 	 	 	</expression>
 	 	 	 	 	 	 	<symbol> ; </symbol>
 	 	 	 	 	 	</letStatement>
 	 	 	 	 	</statements>
 	 	 	 	 	<symbol> } </symbol>
 	 	 	 	</whileStatement>
 	 	 	 	<returnStatement>
 	 	 	 	 	<keyword> return </keyword>
 	 	 	 	 	<expression>
 	 	 	 	 	 	<term>
 	 	 	 	 	 	 	<identifier> out </identifier>
 	 	 	 	 	 	</term>
 	 	 	 	 	</expression>
 	 	 	 	 	<symbol> ; </symbol>
 	 	 	 	</returnStatement>
 	 	 	</statements>
 	 	 	<symbol> } </symbol>
 	 	</subroutineBody>
 	</subroutineDec>
 	<subroutineDec>
 	 	<keyword> function </keyword>
 	 	<keyword> int </keyword>
 	 	<identifier> mod </identifier>
 	 	<symbol> ( </symbol>
 	 	<parameterList>
 	 	 	<keyword> int </keyword>
 	 	 	<identifier> a </identifier>
 	 	 	<symbol> , </symbol>
 	 	 	<keyword> int </keyword>
 	 	 	<identifier> n </identifier>
 	 	</parameterList>
 	 	<symbol> ) </symbol>
 	 	<subroutineBody>
 	 	 	<symbol> { </symbol>
 	 	 	<varDec>
 	 	 	 	<keyword> var </keyword>
 	 	 	 	<keyword> int </keyword>
 	 	 	 	<identifier> q </identifier>
 	 	 	 	<symbol> ; </symbol>
 	 	 	</varDec>
 	 	 	<statements>
 	 	 	 	<letStatement>
 	 	 	 	 	<keyword> let </keyword>
 	 	 	 	 	<identifier> q </identifier>
 	 	 	 	 	<symbol> = </symbol>
 	 	 	 	 	<expression>
 	 	 	 	 	 	<term>
 	 	 	 	 	 	 	<identifier> a </identifier>
 	 	 	 	 	 	</term>
 	 	 	 	 	 	<symbol> / </symbol>
 	 	 	 	 	 	<term>
 	 	 	 	 	 	 	<identifier> n </identifier>
 	 	 	 	 	 	</term>
 	 	 	 	 	</expression>
 	 	 	 	 	<symbol> ; </symbol>
 	 	 	 	</letStatement>
 	 	 	 	<returnStatement>
 	 	 	 	 	<keyword> return </keyword>
 	 	 	 	 	<expression>
 	 	 	 	 	 	<term>
 	 	 	 	 	 	 	<symbol> ( </symbol>
 	 	 	 	 	 	 	<expression>
 	 	 	 	 	 	 	 	<term>
 	 	 	 	 	 	 	 	 	<identifier> a </identifier>
 	 	 	 	 	 	 	 	</term>
 	 	 	 	 	 	 	 	<symbol> - </symbol>
 	 	 	 	 	 	 	 	<term>
 	 	 	 	 	 	 	 	 	<symbol> ( </symbol>
 	 	 	 	 	 	 	 	 	<expression>
 	 	 	 	 	 	 	 	 	 	<term>
 	 	 	 	 	 	 	 	 	 	 	<identifier> n </identifier>
 	 	 	 	 	 	 	 	 	 	</term>
 	 	 	 	 	 	 	 	 	 	<symbol> * </symbol>
 	 	 	 	 	 	 	 	 	 	<term>
 	 	 	 	 	 	 	 	 	 	 	<identifier> q </identifier>
 	 	 	 	 	 	 	 	 	 	</term>
 	 	 	 	 	 	 	 	 	</expression>
 	 	 	 	 	 	 	 	 	<symbol> ) </symbol>
 	 	 	 	 	 	 	 	</term>
 	 	 	 	 	 	 	</expression>
 	 	 	 	 	 	 	<symbol> ) </symbol>
 	 	 	 	 	 	</term>
 	 	 	 	 	</expression>
 	 	 	 	 	<symbol> ; </symbol>
 	 	 	 	</returnStatement>
 	 	 	</statements>
 	 	 	<symbol> } </symbol>
 	 	</subroutineBody>
 	</subroutineDec>
 	<symbol> } </symbol>
</class>
